/**********************************************************************
  R}h/s
  $Id: cmd_exec.c,v 1.4 2002/11/03 03:57:33 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "cmd_funcs.h"
#include "memory.h"
#include "sim_io.h"

#define	SCRIPT_MODE     0
#define	COMMAND_MODE    1
#define	STR_LINE_MAX    256

#ifdef HAVE_READLINE
#include <readline/readline.h>
#include <readline/history.h>
#endif

struct	CMD_TBL_STRUCT{
	char    *cmd_name ;
	int     (*func)() ;
	int     mode ;
} ;

/**************************************
 R}h֐Ăяoe[u
**************************************/
static struct CMD_TBL_STRUCT cmd_tbl[] = {
#include	"cmd_tbl.h"
	{ NULL			, NULL , 0 }	/*** e[uI[ ***/
} ;


int	cmd_exec( char *file )
{
struct	TOKEN_STRUCT	token ;
FILE	*ifp ;
static unsigned char str_line[STR_LINE_MAX] ;
unsigned char   *rdline ;
int		exec_mode ;
static unsigned char prompt[32] = "PPC> \0" ;
int		i,j ;
int		is_tty ;
int id ;

 is_tty=0 ;
 ifp = stdin ;
 id=proc_list.cur_id ;
 if( *file=='-' ){
#ifdef HAVE_READLINE
   exec_mode = COMMAND_MODE ;
#else
   is_tty=isatty(fileno(ifp)) ;
   if( is_tty==1 ) exec_mode = COMMAND_MODE ;
   else            exec_mode = SCRIPT_MODE ;
#endif
 }else{
   if( (ifp = fopen( file , "rb" )) == NULL ){
     SYSMSG("Can not open file(%s).\n",file) ;
     return(FILE_OPEN_ERROR) ;
   }
   exec_mode = SCRIPT_MODE ;
 }
 if( exec_mode == SCRIPT_MODE ) SYSMSG("%s Exec Start \n",file) ;
 
 while( -1 ){
   if( exec_mode == COMMAND_MODE ){
#ifdef HAVE_READLINE
     rdline = readline (prompt) ;
     if( rdline == NULL ){
       break ;
     }
     add_history(rdline) ;
     strncpy( str_line, rdline, STR_LINE_MAX ) ;
#else
     SYSMSG("%s",prompt ) ;
     if( fgets( str_line , STR_LINE_MAX , ifp )==NULL ) break ;
#endif
   }else{
     if( fgets( str_line , STR_LINE_MAX , ifp )==NULL ) break ;
     if( feof(ifp)!=0 ) break ;
     if( exec_mode == SCRIPT_MODE ) SYSMSG("%s",str_line ) ;
   }
   
   if( get_token( str_line , &token )==0 ) continue ;
   
   /*** exitR}h̎s ***/
   if( strcmp((char*)"exit", token.pt[0]) == 0 ){
     break ;
   }
   
   /*** R}hs ***/
   for( i=0 ; ; i++ ){
     if( cmd_tbl[i].cmd_name == NULL ){ /*** OR}h̎s ***/
       if( token.num !=0 ){
	 for( j=0 ; ; j++ ){
	   if( str_line[j]!=' ' && str_line[j]!='\t' ) break ;
	 }
	 if( str_line[j]=='_' ){
	   if( str_line[j+1]=='\0' ||	/* ͂蓾Ȃ? */
	       str_line[j+1]=='\r' || str_line[j+1]=='\n' ){
	     SYSMSG("command not found.\n") ;
	     break ;
	   }
	   j++ ;
	 }
	 system( &str_line[j] ) ;
       }
       break ;
     }
     if( strcmp( cmd_tbl[i].cmd_name, token.pt[0]) == 0 ){ /*** R}h̎s ***/
       if( proc_list.proc[id].mem == NULL ){/*** s蓖ă`FbN ***/
       	 SYSMSG("Memory for simulate is not allocated .\n" ) ;
       	 break ;
       }
       (*cmd_tbl[i].func)( &token , cmd_tbl[i].mode ) ;
       break ;
     }
   }
 }
 if( exec_mode == SCRIPT_MODE ) SYSMSG("done.\n") ;
 return( NORMAL_EXIT ) ;
}
