/**********************************************************************
  ߃fR[h  bit0-5=0b111111 subinstruction set decode
  $Id: op_3f_subfunc.c,v 1.3 2002/11/03 03:57:36 tane Exp $
**********************************************************************/
#include <math.h>
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

/*fcmpu        1 1 1 1 1 1 >crD< 0 0 > A     < > B     < 0 0 0 0 0 0 0 0 0 0 0*/
/*frspx        1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 0 0 1 1 0 0 R*/
/*!!fctiwx       1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 0 0 1 1 1 0 R*/
/*fctiwzx      1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 0 0 1 1 1 1 R*/
/*fcmpo        1 1 1 1 1 1 >crD< 0 0 > A     < > B     < 0 0 0 0 1 0 0 0 0 0 0*/
/*mtfsb1x      1 1 1 1 1 1 >crbD   < 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 R*/
/*fnegx        1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 1 0 1 0 0 0 R*/
/*!!mcrfs        1 1 1 1 1 1 >crD< 0 0 >crS< 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0*/
/*mtfsb0x      1 1 1 1 1 1 >crbD   < 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 R*/
/*fmrx         1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 1 0 0 1 0 0 0 R*/
/*mtfsfix      1 1 1 1 1 1 >crD< 0 0 0 0 0 0 0 > IMM < 0 0 0 1 0 0 0 0 1 1 0 R*/
/*fnabsx       1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 1 0 0 0 1 0 0 0 R*/
/*fabsx        1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 1 0 0 0 0 1 0 0 0 R*/
/*mffsx        1 1 1 1 1 1 > D     < 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0 0 1 1 1 R*/
/*mtfsfx       1 1 1 1 1 1 0 > FM          < 0 > B     < 1 0 1 1 0 0 0 1 1 1 R*/


/*fdivx        1 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 1 0 0 1 0 R*/
/*fsubx        1 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 1 0 1 0 0 R*/
/*faddx        1 1 1 1 1 1 > D     < > A     < > B     < 0 0 0 0 0 1 0 1 0 1 R*/
/*!!fsqrtx(*4,7) 1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 0 1 0 1 1 0 R*/
/*!!fselx(*4)    1 1 1 1 1 1 > D     < > A     < > B     < > C     < 1 0 1 1 1 R*/
/*fmulx        1 1 1 1 1 1 > D     < > A     < 0 0 0 0 0 > C     < 1 1 0 0 1 R*/
/*!!frsqrtex(*4) 1 1 1 1 1 1 > D     < 0 0 0 0 0 > B     < 0 0 0 0 0 1 1 0 1 0 R*/
/*fmsubx       1 1 1 1 1 1 > D     < > A     < > B     < > C     < 1 1 1 0 0 R*/
/*fmaddx       1 1 1 1 1 1 > D     < > A     < > B     < > C     < 1 1 1 0 1 R*/
/*fnmsubx      1 1 1 1 1 1 > D     < > A     < > B     < > C     < 1 1 1 1 0 R*/
/*fnmaddx      1 1 1 1 1 1 > D     < > A     < > B     < > C     < 1 1 1 1 1 R*/


int op_3f_000_func( struct MACHINE_RESOURCE *mres , int mode )  /* fcmpu */
{
  unsigned int fa,fb ;
  unsigned int rd ;
  unsigned int cr ;
  
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  cr= (mres->inst & 0x03800000)>>23 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%cr%d, %%fr%d, %%fr%d\n",cr,fa,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    //FPSCR얢II
    update_crf(mres->FPR[fa].f,mres->FPR[fb].f,cr) ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_00c_func( struct MACHINE_RESOURCE *mres , int mode )  /* frspx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=(float)mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_00f_func( struct MACHINE_RESOURCE *mres , int mode )  /* fctiwzx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  int *cast_int, tmp_int ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    
    cast_int=(int *)&mres->FPR[fd].f ;
    tmp_int = (int)mres->FPR[fb].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    *cast_int = tmp_int ;
    *(cast_int+1)=0 ;
#else
    *cast_int=0 ;
    *(cast_int+1)=tmp_int ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_020_func( struct MACHINE_RESOURCE *mres , int mode )  /* fcmpo */
{
  unsigned int fa,fb ;
  unsigned int rd ;
  unsigned int cr ;
  
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  cr=(mres->inst & 0x03800000)>>23 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    SYSMSG("\t%%cr%d,%%fr%d,%%fr%d\n",cr,fa,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    //FPSCR얢II
    update_crf(mres->FPR[fa].f,mres->FPR[fb].f,cr) ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_026_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtfsb1x */
{
  unsigned int crbd ;
  unsigned int rd ;
  unsigned int flag ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  rd  =(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    if( rd!=0 ) SYSMSG(".") ;
    SYSMSG("\tcrb%d\n",crbd) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;

    if( crbd==0 || crbd==3 ){
    }else{
      flag=0x80000000>>(crbd) ;
      mres->FLGR.fpscr |= flag ;
    }

    mres->pc += 4 ;
  }

  return(0) ;
}


int op_3f_028_func( struct MACHINE_RESOURCE *mres , int mode )  /* fnegx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  unsigned int *fpr_u ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fb].f ;
    fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    fpr_u = fpr_u+1 ;
    *fpr_u= *fpr_u ^ 0x80000000 ;
#else
    *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_046_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtfsb0x */
{
  unsigned int crbd ;
  unsigned int rd ;
  unsigned int flag ;
  
  crbd=(mres->inst & 0x03e00000)>>21 ;
  rd  =(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    if( rd!=0 ) SYSMSG(".") ;
    SYSMSG("\tcrb%d\n",crbd) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;

    if( crbd==0 || crbd==3 ){
    }else{
      flag=0x80000000>>(crbd) ;
      mres->FLGR.fpscr &= ~(flag) ;
    }

    mres->pc += 4 ;
  }

  return(0) ;
}


int op_3f_048_func( struct MACHINE_RESOURCE *mres , int mode )  /* fmrx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_086_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtfsfix */
{
  unsigned int imm ;
  unsigned int rd ;
  unsigned int crfd ;
  
  crfd=(mres->inst & 0x03800000)>>23 ;
  imm =(mres->inst & 0x0000f000)>>12 ;
  rd  =(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    if( rd!=0 ) SYSMSG(".") ;
    SYSMSG("\tcrf%d, %d\n",crfd,imm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    switch( crfd ){
    case 0 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0x6fffffff) | ((imm<<28) & ~(0x6fffffff)) ;
    case 1 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xf0ffffff) | ((imm<<24) & ~(0xf0ffffff)) ;
    case 2 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xff0fffff) | ((imm<<20) & ~(0xff0fffff)) ;
    case 3 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfff0ffff) | ((imm<<16) & ~(0xfff0ffff)) ;
    case 4 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xffff0fff) | ((imm<<12) & ~(0xffff0fff)) ;
    case 5 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfffff0ff) | ((imm<< 8) & ~(0xfffff0ff)) ;
    case 6 :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xffffff0f) | ((imm<< 4) & ~(0xffffff0f)) ;
    default :
      mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfffffff0) | ((imm    ) & ~(0xfffffff0)) ;
    }
    mres->pc += 4 ;
  }

  return(0) ;
}

int op_3f_088_func( struct MACHINE_RESOURCE *mres , int mode )  /* fnabsx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  unsigned int *fpr_u ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fb].f ;
    fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    fpr_u = fpr_u+1 ;
    *fpr_u= *fpr_u | 0x80000000 ;
#else
    *fpr_u= *fpr_u | 0x80000000 ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_108_func( struct MACHINE_RESOURCE *mres , int mode )  /* fabsx */
{
  unsigned int fd,fb ;
  unsigned int rd ;
  unsigned int *fpr_u ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfr(fd,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fb].f ;
    fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    fpr_u = fpr_u+1 ;
    *fpr_u= *fpr_u & 0x7fffffff ;
#else
    *fpr_u= *fpr_u & 0x7fffffff ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_247_func( struct MACHINE_RESOURCE *mres , int mode )  /* mffsx */
{
  unsigned int fd ;
  unsigned int rd ;
  unsigned int *fpr_l ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_fr(fd) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    fpr_l = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    *fpr_l= mres->FLGR.fpscr ;
#else
    fpr_l = fpr_l+1 ;
    *fpr_l= mres->FLGR.fpscr ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_2c7_func( struct MACHINE_RESOURCE *mres , int mode )  /* mtfsfx */
{
  unsigned int fb ;
  unsigned int rd ;
  unsigned int fm ;
  unsigned int tmp ;
  unsigned int *fpr_l ;
  
  fb=(mres->inst & 0x0000f800)>>11 ;
  fm=(mres->inst & 0x01e00000)>>21 ;
  rd=(mres->inst & 0x00000001)     ;

  if( DO_EXEC_DIS(mode) ){
    if( rd!=0 ) SYSMSG(".") ;
    SYSMSG("\t%d, %%f%d\n",fm,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    fpr_l = (unsigned int *)&mres->FPR[fb].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    tmp = *fpr_l ;
#else
    fpr_l = fpr_l+1 ;
    tmp = *fpr_l ;
#endif
    if( (fm & 0x00000080)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0x6fffffff) | (tmp & ~(0x6fffffff)) ;
    if( (fm & 0x00000040)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xf0ffffff) | (tmp & ~(0xf0ffffff)) ;
    if( (fm & 0x00000020)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xff0fffff) | (tmp & ~(0xff0fffff)) ;
    if( (fm & 0x00000010)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfff0ffff) | (tmp & ~(0xfff0ffff)) ;
    if( (fm & 0x00000008)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xffff0fff) | (tmp & ~(0xffff0fff)) ;
    if( (fm & 0x00000004)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfffff0ff) | (tmp & ~(0xfffff0ff)) ;
    if( (fm & 0x00000002)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xffffff0f) | (tmp & ~(0xffffff0f)) ;
    if( (fm & 0x00000001)!=1 ) mres->FLGR.fpscr = (mres->FLGR.fpscr & 0xfffffff0) | (tmp & ~(0xfffffff0)) ;
    
    mres->pc += 4 ;
  }

  return(0) ;
}


int op_3f_x12_func( struct MACHINE_RESOURCE *mres , int mode )  /* fdivx */
{
  unsigned int fd,fa,fb ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfr(fd,fa,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fa].f / mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_x14_func( struct MACHINE_RESOURCE *mres , int mode )  /* fsubx */
{
  unsigned int fd,fa,fb ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfr(fd,fa,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fa].f - mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_x15_func( struct MACHINE_RESOURCE *mres , int mode )  /* faddx */
{
  unsigned int fd,fa,fb ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfr(fd,fa,fb) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fa].f + mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_x19_func( struct MACHINE_RESOURCE *mres , int mode )  /* fmulx */
{
  unsigned int fd,fa,fc ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fc=(mres->inst & 0x000007c0)>>6  ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfr(fd,fa,fc) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=mres->FPR[fa].f * mres->FPR[fc].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}


int op_3f_x1c_func( struct MACHINE_RESOURCE *mres , int mode )  /* fmsubx */
{
  unsigned int fd,fa,fb,fc ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  fc=(mres->inst & 0x000007c0)>>6  ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfrfr(fd,fa,fb,fc) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) - mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_x1d_func( struct MACHINE_RESOURCE *mres , int mode )  /* fmaddx */
{
  unsigned int fd,fa,fb,fc ;
  unsigned int rd ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  fc=(mres->inst & 0x000007c0)>>6  ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfrfr(fd,fa,fb,fc) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) + mres->FPR[fb].f ;
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_x1e_func( struct MACHINE_RESOURCE *mres , int mode )  /* fnmsubx */
{
  unsigned int fd,fa,fb,fc ;
  unsigned int rd ;
  unsigned int *fpr_u ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  fc=(mres->inst & 0x000007c0)>>6  ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfrfr(fd,fa,fb,fc) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) - mres->FPR[fb].f ;
    fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    fpr_u = fpr_u+1 ;
    *fpr_u= *fpr_u ^ 0x80000000 ;
#else
    *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}
  

int op_3f_x1f_func( struct MACHINE_RESOURCE *mres , int mode )  /* fnmaddx */
{
  unsigned int fd,fa,fb,fc ;
  unsigned int rd ;
  unsigned int *fpr_u ;
  
  fd=(mres->inst & 0x03e00000)>>21 ;
  fa=(mres->inst & 0x001f0000)>>16 ;
  fb=(mres->inst & 0x0000f800)>>11 ;
  fc=(mres->inst & 0x000007c0)>>6  ;
  rd=(mres->inst & 0x00000001)     ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_frfrfrfr(fd,fa,fb,fc) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
    mres->FPR[fd].f=(mres->FPR[fa].f * mres->FPR[fc].f) + mres->FPR[fb].f ;
    fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
    fpr_u = fpr_u+1 ;
    *fpr_u= *fpr_u ^ 0x80000000 ;
#else
    *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
    mres->pc += 4 ;
  }
  
  return(0) ;
}
